Index: lib/outputlib.php
=========================================================
--- lib/outputlib.php	(revision 1.46)
+++ lib/outputlib.php	Sat Jul 25 15:13:13 WST 2009
@@ -3229,6 +3672,726 @@
     }
 }
 
+/**
+ * Component representing a XHTML link.
+ *
+ * @copyright 2009 Nicolas Connault
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ * @since     Moodle 2.0
+ */
+class html_link extends moodle_html_component {
+    /**
+     * URL can be simple text or a moodle_url object
+     * @var mixed $url
+     */
+    public $url;
+
+    /**
+     * @var string $text The text that will appear between the link tags
+     */
+    public $text;
+
+    /* @see lib/moodle_html_component#prepare() */
+    public function prepare() {
+        // We can't accept an empty text value
+        if (empty($this->text)) {
+            throw new coding_exception('A html_link must have a descriptive text value!');
+        }
+
+        parent::prepare();
+    }
+}
+
+/**
+ * Component representing a help icon.
+ *
+ * @copyright 2009 Nicolas Connault
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ * @since     Moodle 2.0
+ */
+class help_icon extends moodle_html_component {
+    /**
+     * @var html_link $link A html_link object that will hold the URL info
+     */
+    public $link;
+    /**
+     * @var string $text A descriptive text
+     */
+    public $text;
+    /**
+     * @var string $page  The keyword that defines a help page
+     */
+    public $page;
+    /**
+     * @var string $module Which module is the page defined in
+     */
+    public $module = 'moodle';
+    /**
+     * @var boolean $linktext Whether or not to show text next to the icon
+     */
+    public $linktext = false;
+    /**
+     * @var mixed $image The help icon. Can be set to true (will use default help icon),
+     *                   false (will not use any icon), the URL to an image, or a full
+     *                   html_image object.
+     */
+    public $image;
+
+    public function prepare() {
+        global $COURSE, $OUTPUT;
+
+        if (empty($this->page)) {
+            throw new coding_exception('A help_icon object requires a $page parameter');
+        }
+
+        if (empty($this->text)) {
+            throw new coding_exception('A help_icon object requires a $text parameter');
+        }
+
+        $this->link = new html_link();
+        $this->link->text = $this->text;
+
+        // fix for MDL-7734
+        $this->link->url = new moodle_url('/help.php', array('module' => $this->module, 'file' => $this->page .'.html'));
+
+        // fix for MDL-7734
+        if (!empty($COURSE->lang)) {
+            $this->link->url->param('forcelang', $COURSE->lang);
+        }
+
+        // Catch references to the old text.html and emoticons.html help files that
+        // were renamed in MDL-13233.
+        if (in_array($this->page, array('text', 'emoticons', 'richtext'))) {
+            $oldname = $this->page;
+            $this->page .= '2';
+            debugging("You are referring to the old help file '$oldname'. " .
+                    "This was renamed to '$this->page' because of MDL-13233. " .
+                    "Please update your code.", DEBUG_DEVELOPER);
+        }
+
+        if ($this->module == '') {
+            $this->module = 'moodle';
+        }
+
+        // Warn users about new window for Accessibility
+        $this->title = get_string('helpprefix2', '', trim($this->text, ". \t")) .' ('.get_string('newwindow').')';
+
+        // Prepare image and linktext
+        if ($this->image && !($this->image instanceof html_image)) {
+            $image = fullclone($this->image);
+            $this->image = new html_image();
+
+            if ($image instanceof moodle_url) {
+                $this->image->src = $image->out();
+            } else if ($image === true) {
+                $this->image->src = $OUTPUT->old_icon_url('help');
+            } else if (is_string($image)) {
+                $this->image->src = $image;
+            }
+            $this->image->alt = $this->text;
+
+            if ($this->linktext) {
+                $this->image->alt = get_string('helpwiththis');
+            } else {
+                $this->image->alt = $this->title;
+            }
+            $this->image->add_class('iconhelp');
+        }
+
+        parent::prepare();
+    }
+}
+
+/**
+ * Helper class used by other components that involve an action on the page (URL or JS).
+ *
+ * @copyright 2009 Nicolas Connault
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ * @since     Moodle 2.0
+ */
+class component_action {
+
+    /**
+     * The DOM event that will trigger this action when caught
+     * @var string $event DOM event
+     */
+    public $event;
+
+    /**
+     * The JS function you create must have two arguments:
+     *      1. The event object
+     *      2. An object/array of arguments ($jsfunctionargs)
+     * @var string $jsfunction A function name to call when the button is clicked
+     */
+    public $jsfunction = false;
+
+    /**
+     * @var array $jsfunctionargs An array of arguments to pass to the JS function
+     */
+    public $jsfunctionargs = array();
+
+    /**
+     * Constructor
+     * @param string $event DOM event
+     * @param moodle_url $url A moodle_url object, required if no jsfunction is given
+     * @param string $method 'post' or 'get'
+     * @param string $jsfunction An optional JS function. Required if jsfunctionargs is given
+     * @param array  $jsfunctionargs An array of arguments to pass to the jsfunction
+     * @return void
+     */
+    public function __construct($event, $jsfunction, $jsfunctionargs=array()) {
+        $this->event = $event;
+
+        $this->jsfunction = $jsfunction;
+        $this->jsfunctionargs = $jsfunctionargs;
+
+        if (!empty($this->jsfunctionargs)) {
+            if (empty($this->jsfunction)) {
+                throw new coding_exception('The component_action object needs a jsfunction value to pass the jsfunctionargs to.');
+            }
+        }
+    }
+}
+
+/**
+ * Component action for a popup window.
+ *
+ * @copyright 2009 Nicolas Connault
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ * @since     Moodle 2.0
+ */
+class popup_action extends component_action {
+    /**
+     * @var array $params An array of parameters that will be passed to the openpopup JS function
+     */
+    public $params = array(
+            'height' =>  400,
+            'width' => 500,
+            'top' => 0,
+            'left' => 0,
+            'menubar' => false,
+            'location' => false,
+            'scrollbars' => true,
+            'resizable' => true,
+            'toolbar' => true,
+            'status' => true,
+            'directories' => false,
+            'fullscreen' => false,
+            'dependent' => true);
+
+    /**
+     * Constructor
+     * @param string $event DOM event
+     * @param moodle_url $url A moodle_url object, required if no jsfunction is given
+     * @param string $method 'post' or 'get'
+     * @param array  $params An array of popup parameters
+     * @return void
+     */
+    public function __construct($event, $url, $name='popup', $params=array()) {
+        global $CFG;
+        $this->name = $name;
+
+        $url = new moodle_url($url);
+
+        if ($this->name) {
+            $_name = $this->name;
+            if (($_name = preg_replace("/\s/", '_', $_name)) != $this->name) {
+                throw new coding_exception('The $name of a popup window shouldn\'t contain spaces - string modified. '. $this->name .' changed to '. $_name);
+                $this->name = $_name;
+            }
+        } else {
+            $this->name = 'popup';
+        }
+
+        foreach ($this->params as $var => $val) {
+            if (array_key_exists($var, $params)) {
+                $this->params[$var] = $params[$var];
+            }
+        }
+        parent::__construct($event, 'openpopup', array('url' => $url->out(false, array(), false), 'name' => $name, 'options' => $this->get_js_options($params)));
+    }
+
+    /**
+     * Returns a string of concatenated option->value pairs used by JS to call the popup window,
+     * based on this object's variables
+     *
+     * @return string String of option->value pairs for JS popup function.
+     */
+    public function get_js_options() {
+        $jsoptions = '';
+
+        foreach ($this->params as $var => $val) {
+            if (is_string($val) || is_int($val)) {
+                $jsoptions .= "$var=$val,";
+            } elseif (is_bool($val)) {
+                $jsoptions .= ($val) ? "$var," : "$var=0,";
+            }
+        }
+
+        $jsoptions = substr($jsoptions, 0, strlen($jsoptions) - 1);
+
+        return $jsoptions;
+    }
+}
+
+
+/**
+ * Component representing a XHTML button (input of type 'button').
+ * The renderer will either output it as a button with an onclick event,
+ * or as a form with hidden inputs.
+ *
+ * @copyright 2009 Nicolas Connault
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ * @since     Moodle 2.0
+ */
+class html_button extends moodle_html_component {
+    /**
+     * This URL is used only to set up the component_action associated
+     * with this button. Do not use this value in the renderer!
+     * @var mixed $url A string or a moodle_url object
+     */
+    public $url;
+
+    /**
+     * @var string $label
+     */
+    public $label;
+
+    /**
+     * @var boolean $disabled Whether or not this button is disabled
+     */
+    public $disabled = false;
+
+    /**
+     * @var string $method post or get
+     */
+    public $method = 'post';
+
+    /* @see lib/moodle_html_component#prepare() */
+    public function prepare() {
+        $this->add_class('singlebutton');
+
+        if (empty($this->label)) {
+            throw new coding_exception('A html_button must have a label value!');
+        }
+
+        if (empty($this->url)) {
+            throw new coding_exception('A html_button must have a url value!');
+        }
+
+        if ($this->disabled) {
+            $this->disabled = 'disabled';
+        }
+
+        $this->url = new moodle_url($this->url);
+
+        parent::prepare();
+    }
+}
+
+/**
+ * Component representing an icon linking to a Moodle page.
+ *
+ * @copyright 2009 Nicolas Connault
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ * @since     Moodle 2.0
+ */
+class action_icon extends moodle_html_component {
+    /**
+     * @var mixed $url A string or a moodle_url object
+     */
+    public $url;
+    /**
+     * @var string $title A descriptive text
+     */
+    public $title;
+    /**
+     * @var string $src The path to the image being used
+     */
+    public $src;
+    /**
+     * @var string $linktext Optional text to display next to the icon
+     */
+    public $linktext;
+
+    /**
+     * @var string $method post or get
+     */
+    public $method = 'post';
+
+    public function prepare() {
+        $this->add_class('action-icon');
+
+        parent::prepare();
+
+        if (empty($this->src)) {
+            throw new coding_exception('An action_icon object requires a $src value for its image');
+        }
+    }
+}
+
+/**
+ * Component representing an image.
+ *
+ * @copyright 2009 Nicolas Connault
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ * @since     Moodle 2.0
+ */
+class html_image extends moodle_html_component {
+    /**
+     * @var string $alt A descriptive text
+     */
+    public $alt = HTML_ATTR_EMPTY;
+    /**
+     * @var string $src The path to the image being used
+     */
+    public $src;
+
+    public function prepare() {
+        $this->add_class('image');
+        parent::prepare();
+    }
+}
+
+/**
+ * Component representing a user picture.
+ *
+ * @copyright 2009 Nicolas Connault
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ * @since     Moodle 2.0
+ */
+class user_picture extends moodle_html_component {
+    /**
+     * @var mixed $user A userid or a user object with at least fields id, picture, imagealrt, firstname and lastname set.
+     */
+    public $user;
+    /**
+     * @var int $courseid The course id. Used when constructing the link to the user's profile.
+     */
+    public $courseid;
+    /**
+     * @var html_image $image A custom image used as the user picture.
+     */
+    public $image;
+    /**
+     * @var mixed $url False: picture not enclosed in a link. True: default link. moodle_url: custom link.
+     */
+    public $url;
+    /**
+     * @var int $size Size in pixels. Special values are (true/1 = 100px) and (false/0 = 35px) for backward compatibility
+     */
+    public $size;
+    /**
+     * @var boolean $alttext add non-blank alt-text to the image. (Default true, set to false for purely
+     */
+    public $alttext = true;
+
+    public function prepare() {
+        global $CFG, $DB, $OUTPUT;
+
+        if (empty($this->user)) {
+            throw new coding_exception('A user_picture object must have a $user object before being rendered.');
+        }
+
+        if (empty($this->courseid)) {
+            throw new coding_exception('A user_picture object must have a courseid value before being rendered.');
+        }
+
+        if (empty($this->image)) {
+            $this->image = new html_image();
+        } else if (!($this->image instanceof html_image)) {
+            debugging('user_picture::image must be an instance of html_image', DEBUG_DEVELOPER);
+        }
+
+        $needrec = false;
+        // only touch the DB if we are missing data...
+        if (is_object($this->user)) {
+            // Note - both picture and imagealt _can_ be empty
+            // what we are trying to see here is if they have been fetched
+            // from the DB. We should use isset() _except_ that some installs
+            // have those fields as nullable, and isset() will return false
+            // on null. The only safe thing is to ask array_key_exists()
+            // which works on objects. property_exists() isn't quite
+            // what we want here...
+            if (! (array_key_exists('picture', $this->user)
+                   && ($this->alttext && array_key_exists('imagealt', $this->user)
+                       || (isset($this->user->firstname) && isset($this->user->lastname)))) ) {
+                $needrec = true;
+                $this->user = $this->user->id;
+            }
+        } else {
+            if ($this->alttext) {
+                // we need firstname, lastname, imagealt, can't escape...
+                $needrec = true;
+            } else {
+                $userobj = new StdClass; // fake it to save DB traffic
+                $userobj->id = $user;
+                $userobj->picture = $picture;
+                $this->user = clone($userobj);
+                unset($userobj);
+            }
+        }
+        if ($needrec) {
+            $this->user = $DB->get_record('user', array('id' => $this->user), 'id,firstname,lastname,imagealt');
+        }
+
+        if (!empty($this->link) && empty($this->url)) {
+            $this->url = new moodle_url('/user/view.php', array('id' => $this->user->id, 'course' => $this->courseid));
+        }
+
+        if (empty($this->size)) {
+            $file = 'f2';
+            $this->size = 35;
+        } else if ($this->size === true or $this->size == 1) {
+            $file = 'f1';
+            $this->size = 100;
+        } else if ($this->size >= 50) {
+            $file = 'f1';
+        } else {
+            $file = 'f2';
+        }
+
+        $this->add_class('userpicture');
+
+        if (empty($this->image->src)) {
+            $this->image->src = $this->user->picture;
+        }
+
+        if (!empty($this->image->src)) {
+            require_once($CFG->libdir.'/filelib.php');
+            $this->image->src = new moodle_url(get_file_url($this->user->id.'/'.$file.'.jpg', null, 'user'));
+        } else { // Print default user pictures (use theme version if available)
+            $this->add_class('defaultuserpic');
+            $this->image->src = $OUTPUT->old_icon_url('u/' . $file);
+        }
+
+        if ($this->alttext) {
+            if (!empty($this->user->imagealt)) {
+                $this->image->alt = $this->user->imagealt;
+            } else {
+                $this->image->alt = get_string('pictureof','',fullname($this->user));
+            }
+        }
+
+        parent::prepare();
+    }
+}
+
+/**
+ * Component representing a textarea.
+ *
+ * @copyright 2009 Nicolas Connault
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ * @since     Moodle 2.0
+ */
+class html_textarea extends moodle_html_component {
+    /**
+     * @param string $name Name to use for the textarea element.
+     */
+    public $name;
+    /**
+     * @param string $value Initial content to display in the textarea.
+     */
+    public $value;
+    /**
+     * @param int $rows Number of rows to display  (minimum of 10 when $height is non-null)
+     */
+    public $rows;
+    /**
+     * @param int $cols Number of columns to display (minimum of 65 when $width is non-null)
+     */
+    public $cols;
+    /**
+     * @param bool $usehtmleditor Enables the use of the htmleditor for this field.
+     */
+    public $usehtmleditor;
+
+    public function prepare() {
+        $this->add_class('form-textarea');
+
+        if (empty($this->id)) {
+            $this->id = "edit-$this->name";
+        }
+
+        if ($this->usehtmleditor) {
+            editors_head_setup();
+            $editor = get_preferred_texteditor(FORMAT_HTML);
+            $editor->use_editor($this->id, array('legacy'=>true));
+            $this->value = htmlspecialchars($value);
+        }
+
+        parent::prepare();
+    }
+}
+
+/**
+ * Component representing a simple form wrapper. Its purpose is mainly to enclose
+ * a submit input with the appropriate action and hidden inputs.
+ *
+ * @copyright 2009 Nicolas Connault
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ * @since     Moodle 2.0
+ */
+class html_form extends moodle_html_component {
+    /**
+     * @var string $method post or get
+     */
+    public $method = 'post';
+    /**
+     * If a string is given, it will be converted to a moodle_url during prepare()
+     * @var mixed $url A moodle_url including params or a string
+     */
+    public $url;
+    /**
+     * @var array $params Optional array of parameters. Ignored if $url instanceof moodle_url
+     */
+    public $params = array();
+
+    public function prepare() {
+        if (empty($this->url)) {
+            throw new coding_exception('A html_form must have a $url value (string or moodle_url).');
+        }
+
+        if (!($this->url instanceof moodle_url)) {
+            $this->url = new moodle_url($this->url, $this->params);
+        }
+
+        if ($this->method == 'post') {
+            $this->url->param('sesskey', sesskey());
+        }
+        parent::prepare();
+    }
+}
+
+/**
+ * Component representing a paging bar.
+ *
+ * @copyright 2009 Nicolas Connault
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ * @since     Moodle 2.0
+ */
+class html_paging_bar extends moodle_html_component {
+    /**
+     * @var int $maxdisplay The maximum number of pagelinks to display
+     */
+    public $maxdisplay = 18;
+    /**
+     * @var int $totalcount post or get
+     */
+    public $totalcount;
+    /**
+     * @var int $page The page you are currently viewing
+     */
+    public $page;
+    /**
+     * @var int $perpage The number of entries that should be shown per page
+     */
+    public $perpage;
+    /**
+     * @var $baseurl If this  is a string then it is the url which will be appended with $pagevar, an equals sign and the page number.
+     *      If this is a moodle_url object then the pagevar param will be replaced by the page no, for each page.
+     */
+    public $baseurl;
+    /**
+     * @var string $pagevar This is the variable name that you use for the page number in your code (ie. 'tablepage', 'blogpage', etc)
+     */
+    public $pagevar = 'page';
+    /**
+     * @var bool $nocurr do not display the current page as a link
+     */
+    public $nocurr;
+    /**
+     * @var html_link $previouslink A HTML link representing the "previous" page
+     */
+    public $previouslink = null;
+    /**
+     * @var html_link $nextlink A HTML link representing the "next" page
+     */
+    public $nextlink = null;
+    /**
+     * @var html_link $firstlink A HTML link representing the first page
+     */
+    public $firstlink = null;
+    /**
+     * @var html_link $lastlink A HTML link representing the last page
+     */
+    public $lastlink = null;
+    /**
+     * @var array $pagelinks An array of html_links. One of them is just a string: the current page
+     */
+    public $pagelinks = array();
+
+    public function prepare() {
+        if (!($this->baseurl instanceof moodle_url)) {
+            $this->baseurl = new moodle_url($this->baseurl);
+        }
+
+        if ($this->totalcount > $this->perpage) {
+            $pagenum = $this->page - 1;
+
+            if ($this->page > 0) {
+                $this->previouslink = new html_link();
+                $this->previouslink->add_class('previous');
+                $this->previouslink->url = $this->baseurl->out(false, array($this->pagevar => $pagenum));
+                $this->previouslink->text = get_string('previous');
+            }
+
+            if ($this->perpage > 0) {
+                $lastpage = ceil($this->totalcount / $this->perpage);
+            } else {
+                $lastpage = 1;
+            }
+
+            if ($this->page > 15) {
+                $startpage = $this->page - 10;
+
+                $this->firstlink = new html_link();
+                $this->firstlink->url = $this->baseurl->out(false, array($this->pagevar => 0));
+                $this->firstlink->text = 1;
+                $this->firstlink->add_class('first');
+            } else {
+                $startpage = 0;
+            }
+
+            $currpage = $startpage;
+            $displaycount = $displaypage = 0;
+
+            while ($displaycount < $this->maxdisplay and $currpage < $lastpage) {
+                $displaypage = $currpage + 1;
+
+                if ($this->page == $currpage && empty($this->nocurr)) {
+                    $this->pagelinks[] = $displaypage;
+                } else {
+                    $pagelink = new html_link();
+                    $pagelink->url = $this->baseurl->out(false, array($this->pagevar => $currpage));
+                    $pagelink->text = $displaypage;
+                    $this->pagelinks[] = $pagelink;
+                }
+
+                $displaycount++;
+                $currpage++;
+            }
+
+            if ($currpage < $lastpage) {
+                $lastpageactual = $lastpage - 1;
+                $this->lastlink = new html_link();
+                $this->lastlink->url = $this->baseurl->out(false, array($this->pagevar => $lastpageactual));
+                $this->lastlink->text = $lastpage;
+                $this->lastlink->add_class('last');
+            }
+
+            $pagenum = $this->page + 1;
+
+            if ($pagenum != $displaypage) {
+                $this->nextlink = new html_link();
+                $this->nextlink->url = $this->baseurl->out(false, array($this->pagevar => $pagenum));
+                $this->nextlink->text = get_string('next');
+                $this->nextlink->add_class('next');
+            }
+        }
+    }
+
+}
 
 /**
  * A renderer that generates output for command-line scripts.
@@ -3423,3 +4586,23 @@
         echo "/* @end */\n\n";
     }
 }
+
+/**
+ * Given a moodle_html_component with height and/or width set, translates them
+ * to appropriate CSS rules.
+ *
+ * @param moodle_html_component $component
+ * @return string CSS rules
+ */
+function prepare_legacy_width_and_height($component) {
+    $output = '';
+    if (!empty($component->height)) {
+        debugging('Explicit height given to moodle_html_component leads to inline css. Use a proper CSS class instead.', DEBUG_DEVELOPER);
+        $output = "height: {$component->height}px;";
+    }
+    if (!empty($component->width)) {
+        debugging('Explicit width given to moodle_html_component leads to inline css. Use a proper CSS class instead.', DEBUG_DEVELOPER);
+        $output .= "width: {$component->width}px;";
+    }
+    return $output;
+}
Index: lib/pagelib.php
=========================================================
--- lib/pagelib.php	(revision 1.143)
+++ lib/pagelib.php	Sat Jul 25 10:31:14 WST 2009
@@ -1367,6 +1367,25 @@
     function get_modulerecord() {
         return $this->cm;
     }
+
+    /**
+     * A helper function that takes a moodle_html_component subclass as param.
+     * If that component has an id attribute and an array of valid component_action objects,
+     * it sets up the appropriate event handlers.
+     *
+     * @param moodle_html_component $component
+     * @return void;
+     */
+    public function prepare_event_handlers(&$component) {
+        $actions = $component->get_actions();
+        if (!empty($actions) && is_array($actions) && $actions[0] instanceof component_action) {
+            foreach ($actions as $action) {
+                if (!empty($action->jsfunction)) {
+                    $this->requires->event_handler($component->id, $action->event, $action->jsfunction, $action->jsfunctionargs);
+                }
+            }
+        }
+    }
 }
 
 /**
Index: lib/simpletest/testdeprecatedlib.php
=========================================================
--- lib/simpletest/testdeprecatedlib.php	(revision 0)
+++ lib/simpletest/testdeprecatedlib.php	Fri Jul 24 22:01:50 WST 2009
@@ -0,0 +1,74 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+
+/**
+ * Unit tests for ../deprecatedlib.php.
+ *
+ * @package   moodlecore
+ * @copyright 2009 Tim Hunt
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later (5)
+ */
+
+if (!defined('MOODLE_INTERNAL')) {
+    die('Direct access to this script is forbidden.');    ///  It must be included from a Moodle page
+}
+require_once($CFG->libdir . '/deprecatedlib.php');
+
+class outputlib_methods_test extends UnitTestCase {
+    public function test_print_single_button() {
+        global $PAGE, $CFG;
+
+        // Basic params, absolute URL
+        $link = 'http://www.test.com/index.php';
+        $options = array('param1' => 'value1');
+        $label = 'OK';
+        $method = 'get';
+        $return = true;
+        $tooltip = '';
+        $disabled = false;
+        $jsconfirmmessage = '';
+        $formid = '';
+
+        $html = print_single_button($link, $options, $label, $method, '', $return, $tooltip, $disabled, $jsconfirmmessage, $formid);
+        $this->assert(new ContainsTagWithAttributes('form', array('method' => $method, 'action' => $link)), $html);
+        $this->assert(new ContainsTagWithAttributes('input', array('type' => 'hidden', 'name' => 'param1', 'value' => 'value1')), $html);
+        $this->assert(new ContainsTagWithAttributes('input', array('type' => 'submit', 'value' => 'OK')), $html);
+
+        // URL with &amp; params
+        $newlink = $link . '?param1=value1&amp;param2=value2';
+        $html = print_single_button($newlink, $options, $label, $method, '', $return, $tooltip, $disabled, $jsconfirmmessage, $formid);
+        $this->assert(new ContainsTagWithAttributes('form', array('method' => $method, 'action' => $link)), $html);
+        $this->assert(new ContainsTagWithAttributes('input', array('type' => 'hidden', 'name' => 'param1', 'value' => 'value1')), $html);
+        $this->assert(new ContainsTagWithAttributes('input', array('type' => 'submit', 'value' => 'OK')), $html);
+
+        // URL with & params
+        $newlink = $link . '?param1=value1&param2=value2';
+        $html = print_single_button($newlink, $options, $label, $method, '', $return, $tooltip, $disabled, $jsconfirmmessage, $formid);
+        $this->assert(new ContainsTagWithAttributes('form', array('method' => $method, 'action' => $link)), $html);
+        $this->assert(new ContainsTagWithAttributes('input', array('type' => 'hidden', 'name' => 'param1', 'value' => 'value1')), $html);
+        $this->assert(new ContainsTagWithAttributes('input', array('type' => 'submit', 'value' => 'OK')), $html);
+
+        // relative URL with & params
+        $newlink = 'index.php?param1=value1&param2=value2';
+        $PAGE->set_url('index.php');
+        $html = print_single_button($newlink, $options, $label, $method, '', $return, $tooltip, $disabled, $jsconfirmmessage, $formid);
+        $this->assert(new ContainsTagWithAttributes('form', array('method' => $method, 'action' => $CFG->wwwroot . '/index.php')), $html);
+        $this->assert(new ContainsTagWithAttributes('input', array('type' => 'hidden', 'name' => 'param1', 'value' => 'value1')), $html);
+        $this->assert(new ContainsTagWithAttributes('input', array('type' => 'submit', 'value' => 'OK')), $html);
+    }
+}
